// H.Cohen p.29  Algorithm 1.4.12 Binary Kronecker
// Returns Kronecker symbol (a/b), which, if b is an odd prime, == legendre symbol (a/b)
//Have checked for Legrende Symbol (1000/11) = -1, (14014/5) = 1, (342/113) = -1 and (84/7) = 0
//Is required for PQa LMM.  'Henry Cohen' "A course in computational algebraic number theory"
//Section 1.5 page 31-36.  x^2 = D(mod |m|) where |m| is p a prime.
//

#include <iostream>
#include <cmath>
using namespace std;

int Binary_Kronecker(long long a, long long b)
{
	int Pal_2s[]{ 0, 1, 0, -1, 0, -1, 0, 1 };// (-1)^((a^2-1)/8) == tab2[a & 7]
	int v = 0;
	int k = 0;
	int r = 0;
	bool correct2{}; // Initialised to zero
	bool proper1{}; // so is false
	//Step 1
	do{
		if ((b % 2) == 0) {
			cout << " Even....Input 'b' is an odd prime ? ";
			return b;
			break; }// proper1 = true; }odd prime? still true if p and q positive odd integer
	    if ((b == 0) && (abs(a) != 1)) { return 0; }
	    if ((b == 0) && (abs(a) == 1)) { return 0; }

		if (((a % 2) == 0) && ((b % 2) == 0)) { return 0; proper1 = true;} //Terminate Program
		else if ((b % 2) == 0) {
			v += 1;
			b /= 2; 
		}
		if ((v % 2) == 0) {
			k = 1;
		}
		else
		{
			k *= Pal_2s[a&7]; // *=  
		}
		if (b < 0) {
			b = -b;
		}
		if ((b < 0) && (a < 0)) {
			k = -k;
		}
		//Step 3
		if ((b & 1) && (b > 0)) {
			a = a % b;
		}
		//Step 4
		do {
			if ((a == 0) && (b > 1)) {
				return 0;
				proper1 = true;
				correct2 = true;
			}
			if ((a == 0) && (b == 1)) {
				return k;
				proper1 = true;
				correct2 = true;
			}   //Terminate Program
		//Step 5
			v = 0;
			if ((a % 2) == 0) {
				v += 1;
				a = (a / 2);
				if (v & 1) {
					k *= Pal_2s[b & 7]; 
				}
			}
				//Step 6
			if (((b % 2) == 1) && (a % 2) == 1){   ///((b & 1) && (a & 1)) {
				r = b - a;
				if (r > 0) {
					if ((a&b&2) != 0) { k = -k; }
					b = a;
					a = r;
				}
				else {
					a = -r;
				} //Go to Step 4
			}
			
		} while (correct2 == false);
	} while (proper1 == false);
}
int main() {
	int a;
	int b;
	cout << "Enter a" << endl;
	cin >> a;
	cout << "Enter b" << endl;
	cin >> b;
	cout << "x^2 = a(mod p), p an odd prime. If 'quadratic non residual', result = -1.";
	cout << "If 'quadratic residual', result = 1, If b can be divided by a, result = 0. ";
	cout << "Binary_Kronecker symbol (a/b) is = ";
	cout << Binary_Kronecker(a,b) << endl;
}
